from abc import ABC, abstractmethod
from typing import List

from botrun_ask_folder.models.drive_folder import DriveFolder
from botrun_ask_folder.models.drive_file import DriveFile
from botrun_ask_folder.models.splitted_file import SplittedFile


class DriveClient(ABC):
    @abstractmethod
    async def get_drive_folder(self, id: str) -> DriveFolder:
        pass

    @abstractmethod
    async def set_drive_folder(self, folder: DriveFolder) -> DriveFolder:
        pass

    @abstractmethod
    async def delete_drive_folder(self, id: str) -> bool:
        pass

    @abstractmethod
    async def get_drive_file(self, id: str) -> DriveFile:
        pass

    @abstractmethod
    async def set_drive_file(self, file: DriveFile) -> DriveFile:
        pass

    @abstractmethod
    async def delete_drive_file(self, id: str) -> bool:
        pass

    @abstractmethod
    async def get_splitted_file(self, id: str) -> SplittedFile:
        pass

    @abstractmethod
    async def set_splitted_file(self, file: SplittedFile) -> SplittedFile:
        pass

    @abstractmethod
    async def delete_splitted_file(self, id: str) -> bool:
        pass

    @abstractmethod
    async def update_drive_files(self, folder_id: str, new_files: List[DriveFile]):
        pass

    @abstractmethod
    async def get_split_files(self, folder_id: str):
        pass

    @abstractmethod
    async def get_drive_files(self, folder_id: str) -> List[DriveFile]:
        pass
